package wifky::autolink;

# use strict; use warnings;

$::preferences{AutoLink} = [
    {
        desc =>'Prefix for title of autolinked page' , 
        name =>'autolink_prefix' 
    },
    { 
        desc =>'Postfix for title of autolinked page',
        name =>'autolink_postfix' 
    },
];

my $prefix =$::config{autolink_prefix};
my $postfix=$::config{autolink_postfix};

if( $postfix || $prefix ){
    my $start=unpack('h*',$prefix||'');
    my $end  =unpack('h*',$postfix||'');
    my @symbols =
         sort{ length($b->[0]) <=> length($a->[0]) }
         map{ 
            if( /^\Q$start\E(.+?)\Q$end\E$/ ){
                my $page=pack('h*',$&);
                my $word=pack('h*',$1);
                $word =~ s/^\s+//; $word =~ s/\s+$//;
                [ $word , $page ]
            }else{
                ();
            }
        } &::list_page();

    $::inline_syntax_plugin{'901_autolink'} = sub{
        my $text=shift;
        foreach my $p ( @symbols ){
            $$text =~ s/\Q$p->[0]\E/&::anchor($p->[0],{ p=>$p->[1] })/ge;
        }
    };
}
